package com.dgtly.wxportal.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.dgtly.wxportal.service.ESignService;
import com.dgtly.wxportal.utils.ESign.ESignHttpUtil;
import com.dgtly.wxportal.utils.ESign.ESignUploadUtil;
import com.dgtly.wxportal.utils.ESign.ESignUrl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;

/**
 * @author ZhangDing
 * @version 1.0
 * @descption: TODO
 * @company 神州数码通用软件（洛阳）有限公司
 * @copyright (c) 2019 LuoYang DGT Co'Ltd Inc. All rights reserved.
 * @date 2020-10-10 11:27
 * @since JDK1.8
 */
@Service
public class ESignServiceImpl implements ESignService {

    @Autowired
    private ESignHttpUtil eSignHttpUtil;

    @Override
    public String upload(String orderId) {
        //根据订单id生成pdf文件
        String filePath = creatPdf(orderId);
        String md5 = ESignUploadUtil.getStringContentMD5(filePath);
        String contentTtpe = "application/pdf";
        int fileLength = ESignUploadUtil.getFileSize(filePath);
        //根据文件获取上传路径
        JSONObject urlData =  getUpUrl(filePath,md5,contentTtpe,fileLength).getJSONObject("data");
        //文件id
        String fileId = urlData.getString("fileId");
        //文件上传路径
        String uploadUrl = urlData.getString("uploadUrl");


        //上传文件
        String res = eSignHttpUtil.upLoadFile(uploadUrl,filePath,md5,contentTtpe,fileLength);

        return res;
    }

    /**
     * 创建收货单pdf文件
     * @param orderId
     * @return
     */
    private String creatPdf(String orderId){

        return "D:/bc.pdf";
    }

    /**
     * 获取文件上传路径
     * @param filePath
     * @return
     */
    private JSONObject getUpUrl(String filePath,String contentMd5,String contentType,int fileLength){
        File file = new File(filePath);
        String fileName = file.getName();
        JSONObject json = new JSONObject();
        json.put("contentMd5", contentMd5);
        json.put("contentType",contentType);
        json.put("convert2Pdf",false);
        json.put("fileName",fileName);
        json.put("fileSize",fileLength);
        JSONObject result=  eSignHttpUtil.doPostGetJson(ESignUrl.uploadCreateFile,json);
        return result;
    }

}
