package com.dgtly.wxportal.utils.ESign;

import com.dgtly.wxportal.config.ESignConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.EnumSet;
import java.util.Formatter;


public enum ESignUrl {
    //获取token方法
    AccessToken("/v1/oauth2/access_token?appId=%s&secret=%s&grantType=client_credentials")
    ,CreatePersonalAccount("/v1/accounts/createByThirdPartyUserId")
    ,GetPersonalAddress("/v2/identity/auth/web/%s/indivIdentityUrl")
    ,CreateThirdParty("/v1/organizations/createByThirdPartyUserId")
    ,uploadCreateFile("/v1/files/getUploadUrl")
    ;
    private String url;
    private ESignConfig eSignConfig ;

    ESignUrl(String url){

        this.url = url;
    }


    public String getUrl(Object ... args) {
        String str = eSignConfig.geteSignServiceUrl()+url;
        switch (this){
            case AccessToken:
                str= new Formatter().format(str, eSignConfig.getAppId(),eSignConfig.getAppSecret()).toString();
                break;
            default:
                str= new Formatter().format(str, args).toString();
                break;
        }
        return str;
    }

    public void setESignConfig(ESignConfig eSignConfig){
        this.eSignConfig = eSignConfig;
    }






    @Component
    public static class ESignServiceAutowired {

        @Autowired
        private ESignConfig eSignConfig ;

        @PostConstruct
        public void postConstruct() {
            for (ESignUrl type : EnumSet.allOf(ESignUrl.class)){
                type.setESignConfig(eSignConfig);
            }
        }
    }


}
